require('systems.mapsystem')
require('systems.camerasystem')
require('systems.inputsystem')

SystemManager = {
 
 Systems = {
    Input = InputSystem,
    Camera = CameraSystem,
    Map = MapSystem
  }
  
}

--Probably remove this for a loader system
function SystemManager:load()
  CameraSystem:load(self)
  InputSystem:load(self)
  MapSystem:load(self, 10, 10)
end

function SystemManager:update(dt)
  for k, system in pairs(self.Systems) do
    system:update(dt)
  end
end

function SystemManager:draw()
  CameraSystem:set()
  for k, system in pairs(self.Systems) do
    if system.draw ~= nil then
      system:draw()
    end
  end
  CameraSystem:unset()
end

function SystemManager:findSystem(name, ...)
  local tags = {...}
  local arr = {}
  
  if name ~= nil then
    arr[1] = self.Systems[name]
  end
  
  for i, v in ipairs(tags) do
    --TODO
  end
  
  return unpack(arr)
end