require('systems.system')
require('components.componentgenerator')
require('libs.map')

InputSystem = System:new()

function InputSystem:load(systemManager)
  local mouse = ComponentGenerator:generate("Mouse")
  self:addComponent(mouse)
  
  self.SystemManager = systemManager
end

local function generateMouse(system, dt)
  local mouseObj = system:findComponent('Mouse')
  local isDown = love.mouse.isDown(1)
  local currentX, currentY = love.mouse.getPosition()
  local mpos = Vector:new(currentX, currentY)
  local scroll = InputSystem.WheelMoved
  
  --Clear it
  InputSystem.WheelMoved = nil
  
  if mouseObj.isDown then
    if mouseObj.Clicked == nil then
      mouseObj.Clicked = mpos
    elseif mouseObj.Position ~= nil then
      local xd = mouseObj.Position.X - mpos.X
      local yd = mouseObj.Position.Y - mpos.Y
      --print("Dragged amount -- X: "..xd.." Y: "..yd)    
      mouseObj.Dragged = Vector:new(xd, yd)
    end
    mouseObj.DownTime = mouseObj.DownTime + dt
  else
    mouseObj.Clicked = nil
    mouseObj.Dragged = nil
    mouseObj.DownTime = 0
  end
  
  mouseObj.Position = mpos or Vector:new(0,0)
  mouseObj.Scrolled = scroll
  --print("Current POS -- X: "..mpos.X.." Y: "..mpos.Y)
  
  mouseObj.isDown = isDown
end

local function generateKeys()
  
end

function InputSystem:update(dt)
  generateMouse(self, dt)
end

function InputSystem:poll(name, ...)
  return map(self:findComponent(name), ...)
end

--Bind to the love wheel
function love.wheelmoved(x, y)
  InputSystem.WheelMoved = Vector:new(x,y)
end