System = {}
System_mt = { index = System }

function System:new()
  local system = {
    Components = {},
    addComponent = function (system, comp)
      system.Components[#system.Components + 1] = comp
    end,
    removeComponent = function (system, comp)
      local new_arr = {}
      for i,c in ipairs(system.Components) do
        if comp ~= c then
          new_arr[#new_arr] = c
        end
      end
    end,
    findComponent = function (system, name)
      for i,c in ipairs(system.Components) do
        if c.Name == name then
          return c
        end
      end
      
      return nil
    end
  }
  
  system.__index = system
  setmetatable(system, System)
  
  return system
end