require('world.tiles.tilegenerator')
require('libs.vector')

local TILE_SIZE = 216
local TILE_X_OFFSET = 14
local TILE_Y_OFFSET = 28
local TILE_X_SCALE = 50
local TILE_Y_SCALE = 95

Map = {
  
  Width = 0,
  Height = 0,
  
  Tiles = {},
  Entities = {},
  Camera = nil,
  
  determineTilePos = function (self, i) 
    local x_g = (i % self.Width)
    local y_g = math.floor(i / self.Width)
    
    local x = x_g * (TILE_SIZE - (TILE_X_OFFSET*2)) - (x_g*TILE_X_SCALE)
    local y = y_g * (TILE_SIZE - (TILE_Y_OFFSET*2) - TILE_Y_SCALE) + (x_g*TILE_Y_OFFSET)
    
    --print("X_G: "..x_g.." Y_G: "..y_g.." X: "..x.." Y: "..y)
    
    return Vector:new(x_g, y_g), Vector:new(x,y)
  end
  
}

function Map:load(width, height)
  self.Width = width
  self.Height = height
  
  local tCount = width * height
  
  for i = 0, tCount, 1 do
    local bpos, pos = self:determineTilePos(i)
    local t = TileGenerator:generate('debug', i, bpos, pos)
    self.Tiles[#self.Tiles + 1] = t
  end
end

function Map:update(dt)
  for k, tile in pairs(self.Tiles) do
    tile:update(dt)
  end
end

function Map:draw()
  for k, tile in pairs(self.Tiles) do
    tile:draw()
  end
end