require('libs.animations')
require('libs.vector')

local function createTile(index, bpos, pos)
  local tile = {
    Gid = index,
    Pos = pos,
    BoardPos = bpos,
    Animation = Animation:new()
  }
  
  function tile:load(path, rows, cols, duration, offset, startGid, endGid, name)
    self.Animation:addAnimation(path, rows, cols, duration, offset, startGid, endGid, name)
  end
  
  function tile:draw()
    --love.graphics.print("Gid: "..self.Gid.." X: "..self.Pos.X.." Y: "..self.Pos.Y, self.Pos.X + 150, self.Pos.Y - 128)
    --love.graphics.print(" BX: "..self.BoardPos.X.." BY: "..self.BoardPos.Y, self.Pos.X + 150, self.Pos.Y - 48)
    
    self.Animation:draw(self.Pos, self.Animation.ScaleX, self.Animation.ScaleY)
  end
  
  function tile:update()
    
  end
  
  return tile
end


TileGenerator = {
  
  debug = function (index, bpos, pos)
    local dt = createTile(index, bpos, pos)
    
    --addAnimation(path, rows, columns, duration, offset, startGid, endGid, name)
    dt:load('assets/debug/tiles/HEX_Dirt_01.png', 1, 1, 0, Vector:new(0,0), 1, 1, 1, 'tile')
    
    return dt
  end,

}

function TileGenerator:generate(name, index, bpos, pos)
  return self[name](index, bpos, pos)
end